/* 
Parallel Fractal Demonstration - ParallelFractalMain.c
Copyright  2001-6  Dean E. Dauger

****************************************************************
License:

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU General Public License is available by:
Writing to the Free Software Foundation, Inc., 
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
or http://www.fsf.org/copyleft/gpl.html

****************************************************************

See ParallelFractalEngine.c for additional information
*/
#ifdef __MWERKS__
#define TARGET_API_MAC_CARBON 1

#include <fp.h>

#include <Events.h>						/* SystemClick */
#include <Quickdraw.h>					/* InitGraf,InitCursor */
#include <Menus.h>						/* InitMenus */
#include <Fonts.h>						/* InitFonts */
#include <MacTypes.h>						/* Rect struct typedef */
#include <Sound.h>						/* SysBeep */
#include <SegLoad.h>					/* ExitToShell */
#include <ToolUtils.h> 					/* for HiWord,LoWord */
#include <MacWindows.h>
#include <Gestalt.h>

#include <AppleEvents.h>
#include <AEObjects.h>
#include <AEPackObject.h>

#include <Errors.h>
#else
#include <Carbon/Carbon.h>
#endif

#include "PoochAECodes.h"
#define poochCreatorCode			'POCH'
#include "PoochCalls.h"

Boolean LocateLocalAppWithCreatorCode(ProcessSerialNumber *outPSN, FSSpec *outFSS, OSType creatorCode)
	{Boolean out=false; 
	ProcessSerialNumber psn={0,kNoProcess}; 
					
	while (procNotFound!=GetNextProcess(&psn)) {
		ProcessInfoRec pir; 
		FSSpec fs; 
		Str63 name; 
		pir.processInfoLength=sizeof(ProcessInfoRec); 
		pir.processName=name; 
		pir.processAppSpec=&fs; 
		if (noErr==GetProcessInformation(&psn, &pir)) 
			{
			
			switch (pir.processType) {
				default: 
					break; 
				case 'APPL': 
					if (creatorCode==pir.processSignature) {
						if (outPSN) *outPSN=psn; 
						if (outFSS) *outFSS=fs; 
						out=true; 
						}
					break; 
				}
							
			}
		}
	
	return out; 	
	}

OSErr LocateMe(FSSpec *outFSS)
			//locate me
	{
	ProcessSerialNumber psn; 
	FSSpec mySpec; OSErr err; 
					
	psn.highLongOfPSN=0; 
	psn.lowLongOfPSN=kNoProcess; 
	
	err=GetCurrentProcess(&psn); 
	if (noErr==err) {
		ProcessInfoRec pir; 
		FSSpec fs; 
		Str63 name; 
		pir.processInfoLength=sizeof(ProcessInfoRec); 
		pir.processName=name; 
		pir.processAppSpec=&fs; 
		err=GetProcessInformation(&psn, &pir); 
		if (noErr==err) {
			mySpec=pir.processAppSpec[0]; //should be me
			}
		}
			
#ifndef __MWERKS__
	if (1) {// What if I'm a bundle?
			CFBundleRef mainBundle=CFBundleGetMainBundle(); 
			if (mainBundle) {
				CFURLRef mainURL=CFBundleCopyBundleURL(mainBundle); 
				if (mainURL) {
					FSRef myFSRef; 
					FSSpec myFS; 
					if (CFURLGetFSRef(mainURL, &myFSRef)) 
						err=FSGetCatalogInfo(&myFSRef, kFSCatInfoNone, nil, nil, &myFS, nil); 
					if (noErr==err) {
						mySpec=myFS; 
						}
					CFRelease(mainURL); 
					}
				
				}
			}
#endif

	if (noErr==err) 
					//launch on node 0
		{
		if (outFSS) outFSS[0]=mySpec; 
		}
	
	return err; 
	}


OSErr PutMeInForeground(); 
OSErr PutMeInForeground()
			//launch me, so that I will be in the foreground
	{
	FSSpec mySpec; OSErr err; 
					
	err=LocateMe(&mySpec); 
			
	if (noErr==err) 
					//launch on node 0
		{LaunchParamBlockRec lpbr; 
									
		lpbr.launchBlockID=extendedBlock; 
		lpbr.launchEPBLength=extendedBlockLen; 
		lpbr.launchFileFlags=0; 
		lpbr.launchControlFlags=launchContinue+launchNoFileFlags; 
		lpbr.launchAppSpec=&mySpec; 
		lpbr.launchAppParameters=nil; 
		err=LaunchApplication(&lpbr); 
			
		if (noErr==err) {
			}
		else {
			}
		}
	
	return err; 
	}

OSErr TellPSNMakeNewJob(AppleEvent *replyObj, ProcessSerialNumber *poochPSN); 
OSErr TellPSNMakeNewJob(AppleEvent *replyObj, ProcessSerialNumber *poochPSN)
	{
	OSErr err, out; 
	
	if (replyObj&&poochPSN) 
		{
		AEAddressDesc targetAddr; 
		err=AECreateDesc(typeProcessSerialNumber, poochPSN, sizeof(ProcessSerialNumber), &targetAddr); 

		if (noErr==err) {
			AppleEvent myAE; 
			
			err=AECreateAppleEvent(kAECoreSuite, kAECreateElement, /*make */
				&targetAddr, kAutoGenerateReturnID, kAnyTransactionID, &myAE); 
			Debugger(); 
			if (noErr==err) {
				DescType dt=typeJob; 
				/*  new job */
				err=AEPutKeyPtr(&myAE, keyAEObjectClass, typeType, &dt, sizeof(DescType)); 
				
				if (noErr==err) {
					AppleEvent reply; 
					
					err = AESend(&myAE, &reply, kAEWaitReply|kAEAlwaysInteract|kAECanSwitchLayer, 
						kAEHighPriority, kAEDefaultTimeout, nil, nil); 
					
					if (noErr==err) {
						/* result goes here */
						out=err=AEGetKeyDesc(&reply, keyDirectObject, typeWildCard, replyObj); 
						
						err=AEDisposeDesc(&reply); 
						}
					else {
						out=err; 
						}
					
					}
				else 
					out=err; 
				
				err = AEDisposeDesc(&myAE); 
				}
		
			err = AEDisposeDesc(&targetAddr); 
			}
		else out=err; 
		
		}
	else out=paramErr; 
	
	return out; 
	}

OSErr TellPSNNodeScan(AppleEvent *replyObj, ProcessSerialNumber *poochPSN, long forBest); 
OSErr TellPSNNodeScan(AppleEvent *replyObj, ProcessSerialNumber *poochPSN, long forBest)
	{
	OSErr err, out; 
	
	if (replyObj&&poochPSN) 
		{
		AEAddressDesc targetAddr; 
		err=AECreateDesc(typeProcessSerialNumber, poochPSN, sizeof(ProcessSerialNumber), &targetAddr); 

		if (noErr==err) {
			AppleEvent myAE; 
			
			err=AECreateAppleEvent(poochSignature, scanID, /*node scan */
				&targetAddr, kAutoGenerateReturnID, kAnyTransactionID, &myAE); 
			if (noErr==err) {
				if (forBest>0) {
					/*  for best */
					err=AEPutKeyPtr(&myAE, bestID, typeLongInteger, &forBest, sizeof(long)); 
					}
				
				if (noErr==err) {
					AppleEvent reply; 
					
					err = AESend(&myAE, &reply, kAEWaitReply|kAEAlwaysInteract|kAECanSwitchLayer, 
						kAEHighPriority, kAEDefaultTimeout, nil, nil); 
					
					if (noErr==err) {
						/* result goes here */
						out=err=AEGetKeyDesc(&reply, keyDirectObject, typeWildCard, replyObj); 
						
						err=AEDisposeDesc(&reply); 
						}
					else 
						out=err; 
					
					}
				else 
					out=err; 
				
				err = AEDisposeDesc(&myAE); 
				}
		
			err = AEDisposeDesc(&targetAddr); 
			}
		else out=err; 
		
		}
	else out=paramErr; 
	
	return out; 
	}

OSErr TellPSNMakeNewNodes(ProcessSerialNumber *poochPSN, AEDesc *jobDesc, AEDesc *nodeDesc); 
OSErr TellPSNMakeNewNodes(ProcessSerialNumber *poochPSN, AEDesc *jobDesc, AEDesc *nodeDesc)
	{
	OSErr err, out; 
	
	if (jobDesc&&poochPSN&&nodeDesc) 
		{
		AEAddressDesc targetAddr; 
		err=AECreateDesc(typeProcessSerialNumber, poochPSN, sizeof(ProcessSerialNumber), &targetAddr); 

		if (noErr==err) {
			AppleEvent myAE; 
			
			err=AECreateAppleEvent(kAECoreSuite, kAECreateElement, /*make */
				&targetAddr, kAutoGenerateReturnID, kAnyTransactionID, &myAE); 
			if (noErr==err) {
				DescType dt=typeNode; 
				/*  new node  */
				err=AEPutKeyPtr(&myAE, keyAEObjectClass, typeType, &dt, sizeof(DescType)); 
				
				if (noErr==err) {
					/*  at j  */
					err=AEPutKeyDesc(&myAE, keyAEInsertHere, jobDesc); 
					
					if (noErr==err) {
						/*  with properties  */
						err=AEPutKeyDesc(&myAE, keyAEPropData, nodeDesc); 
						
						if (noErr==err) {
							AppleEvent reply; 
					
							err = AESend(&myAE, &reply, kAENoReply|kAEAlwaysInteract|kAECanSwitchLayer, 
								kAEHighPriority, kAEDefaultTimeout, nil, nil); 
							
							out=err; 
							
							if (noErr==err) {
								
								}
							else 
								out=err; 
							
							}
						else 
							out=err; 
						
						}
					else 
						out=err; 
					
					}
				else 
					out=err; 
				
				err = AEDisposeDesc(&myAE); 
				}
		
			err = AEDisposeDesc(&targetAddr); 
			}
		else out=err; 
		
		}
	else out=paramErr; 
	
	return out; 
	}

OSErr TellPSNMakeNewFSS(ProcessSerialNumber *poochPSN, AEDesc *jobDesc, FSSpec *fss); 
OSErr TellPSNMakeNewFSS(ProcessSerialNumber *poochPSN, AEDesc *jobDesc, FSSpec *fss)
	{
	OSErr err, out; 
	
	if (jobDesc&&poochPSN&&fss) 
		{
		AEAddressDesc targetAddr; 
		err=AECreateDesc(typeProcessSerialNumber, poochPSN, sizeof(ProcessSerialNumber), &targetAddr); 

		if (noErr==err) {
			AppleEvent myAE; 
			
			err=AECreateAppleEvent(kAECoreSuite, kAECreateElement, /*make */
				&targetAddr, kAutoGenerateReturnID, kAnyTransactionID, &myAE); 
			if (noErr==err) {
				DescType dt=cFile; 
				/*  new file  */
				err=AEPutKeyPtr(&myAE, keyAEObjectClass, typeType, &dt, sizeof(DescType)); 
				
				if (noErr==err) {
					/*  at j  */
					err=AEPutKeyDesc(&myAE, keyAEInsertHere, jobDesc); 
					
					if (noErr==err) {
						/*  with data  */
						err=AEPutKeyPtr(&myAE, keyAEData, typeFSS, fss, sizeof(FSSpec)); 
						
						if (noErr==err) {
							AppleEvent reply; 
					
							err = AESend(&myAE, &reply, kAENoReply|kAEAlwaysInteract|kAECanSwitchLayer, 
								kAEHighPriority, kAEDefaultTimeout, nil, nil); 
							
							out=err; 
							
							if (noErr==err) {
								
								}
							else 
								out=err; 
							
							}
						else 
							out=err; 
						
						}
					else 
						out=err; 
					
					}
				else 
					out=err; 
				
				err = AEDisposeDesc(&myAE); 
				}
		
			err = AEDisposeDesc(&targetAddr); 
			}
		else out=err; 
		
		}
	else out=paramErr; 
	
	return out; 
	}

OSErr TellPSNSetJobFlag(ProcessSerialNumber *poochPSN, DescType flag, AEDesc *jobDesc, DescType yn); 
OSErr TellPSNSetJobFlag(ProcessSerialNumber *poochPSN, DescType flag, AEDesc *jobDesc, DescType yn)
	{
	OSErr err, out; 
	
	if (jobDesc&&poochPSN) 
		{
		AEAddressDesc targetAddr; 
		err=AECreateDesc(typeProcessSerialNumber, poochPSN, sizeof(ProcessSerialNumber), &targetAddr); 

		if (noErr==err) {
			AppleEvent myAE; 
			
			err=AECreateAppleEvent(kAECoreSuite, 'setd', /*set */
				&targetAddr, kAutoGenerateReturnID, kAnyTransactionID, &myAE); 
			if (noErr==err) {
				AEDesc flagData; 
				err=AECreateDesc(typeType, &flag, sizeof(DescType), &flagData); 
				if (noErr==err) {
					AEDesc objSpec; 
					
					/*  flag of jobDesc  */
					err=CreateObjSpecifier(typeProperty, jobDesc, formPropertyID, &flagData, false, &objSpec); 
					
					if (noErr==err) {
						err=AEPutKeyDesc(&myAE, keyDirectObject, &objSpec); 
						
						AEDisposeDesc(&objSpec); 
						}
					else 
						out=err; 
					
					AEDisposeDesc(&flagData); 
					}
				else 
					out=err; 
				
				/*  to yn */
				err=AEPutKeyPtr(&myAE, keyAEData, typeEnumerated, &yn, sizeof(DescType)); 
				
				if (noErr==err) {
					AppleEvent reply; 
					
					err = AESend(&myAE, &reply, kAENoReply|kAEAlwaysInteract|kAECanSwitchLayer, 
						kAEHighPriority, kAEDefaultTimeout, nil, nil); 
					
					out=err;
					
					if (noErr==err) {
						}
					else 
						out=err; 
					
					}
				else 
					out=err; 
				
				err = AEDisposeDesc(&myAE); 
				}
		
			err = AEDisposeDesc(&targetAddr); 
			}
		else out=err; 
		
		}
	else out=paramErr; 
	
	return out; 
	}

OSErr TellPSNDeleteNodeOfJob(ProcessSerialNumber *poochPSN, long itemNo, AEDesc *jobDesc); 
OSErr TellPSNDeleteNodeOfJob(ProcessSerialNumber *poochPSN, long itemNo, AEDesc *jobDesc)
	{
	OSErr err, out; 
	
	if (jobDesc&&poochPSN&&(itemNo>0)) 
		{
		AEAddressDesc targetAddr; 
		err=AECreateDesc(typeProcessSerialNumber, poochPSN, sizeof(ProcessSerialNumber), &targetAddr); 

		if (noErr==err) {
			AppleEvent myAE; 
			
			err=AECreateAppleEvent(kAECoreSuite, kAEDelete, /*delete */
				&targetAddr, kAutoGenerateReturnID, kAnyTransactionID, &myAE); 
			if (noErr==err) {
				AEDesc itemNoDesc; 
				err=AECreateDesc(typeLongInteger, &itemNo, sizeof(long), &itemNoDesc); 
				if (noErr==err) {
					AEDesc objSpec; 
					
					/*  node itemNo of jobDesc  */
					err=CreateObjSpecifier(typeNode, jobDesc, formAbsolutePosition, &itemNoDesc, false, &objSpec); 
					
					if (noErr==err) {
						err=AEPutKeyDesc(&myAE, keyDirectObject, &objSpec); 
						
						AEDisposeDesc(&objSpec); 
						}
					else 
						out=err; 
					
					AEDisposeDesc(&itemNoDesc); 
					}
				else 
					out=err; 
				
				if (noErr==err) {
					AppleEvent reply; 
					
					err = AESend(&myAE, &reply, kAENoReply|kAEAlwaysInteract|kAECanSwitchLayer, 
						kAEHighPriority, kAEDefaultTimeout, nil, nil); 
					
					out=err;
					
					if (noErr==err) {
						}
					else 
						out=err; 
					
					}
				else 
					out=err; 
				
				err = AEDisposeDesc(&myAE); 
				}
		
			err = AEDisposeDesc(&targetAddr); 
			}
		else out=err; 
		
		}
	else out=paramErr; 
	
	return out; 
	}

OSErr TellPSNLaunch(ProcessSerialNumber *poochPSN, AEDesc *jobDesc); 
OSErr TellPSNLaunch(ProcessSerialNumber *poochPSN, AEDesc *jobDesc)
	{
	OSErr err, out; 
	
	if (jobDesc&&poochPSN) 
		{
		AEAddressDesc targetAddr; 
		err=AECreateDesc(typeProcessSerialNumber, poochPSN, sizeof(ProcessSerialNumber), &targetAddr); 

		if (noErr==err) {
			AppleEvent myAE; 
			
			err=AECreateAppleEvent(poochSignature, launchID, /*launch */
				&targetAddr, kAutoGenerateReturnID, kAnyTransactionID, &myAE); 
			if (noErr==err) {
				/*  jobDesc */
				err=AEPutKeyDesc(&myAE, keyDirectObject, jobDesc); 
				
				if (noErr==err) {
					AppleEvent reply; 
					
					err = AESend(&myAE, &reply, kAEWaitReply|kAEAlwaysInteract|kAECanSwitchLayer, 
						kAEHighPriority, kAEDefaultTimeout, nil, nil); 
					
					out=err; 
					
					if (noErr==err) {
						
						err=AEDisposeDesc(&reply); 
						}
					else 
						out=err; 
					
					}
				else 
					out=err; 
				
				err = AEDisposeDesc(&myAE); 
				}
		
			err = AEDisposeDesc(&targetAddr); 
			}
		else out=err; 
		
		}
	else out=paramErr; 
	
	return out; 
	}

OSErr LaunchOntoNodes(FSSpec *appFS, long numNodes, short waitForLaunchCompletion)
	{
	OSErr err, out=noErr; 
	ProcessSerialNumber poochPSN; 
	
	if (LocateLocalAppWithCreatorCode(&poochPSN, nil, poochCreatorCode)) 
		{
		AEDesc jobObject; 
		
		out=noErr; 
		
		//	set j to make new job
		err=TellPSNMakeNewJob(&jobObject, &poochPSN); 
		
		if (noErr==err) {
			
			//	make new file at j with data file appFS
			err=TellPSNMakeNewFSS(&poochPSN, &jobObject, appFS); 
			
			if (noErr==err) {
				AEDesc nodeListDesc; 
					
				//	set n to node scan for best numNodes
				err=TellPSNNodeScan(&nodeListDesc, &poochPSN, numNodes); 
				
				if (noErr==err) {
				
					//	make new node at j with properties n
					err=TellPSNMakeNewNodes(&poochPSN, &jobObject, &nodeListDesc); 
					
					if (noErr==err) {
						
						//	set node zero skip of j to yes
						err=TellPSNSetJobFlag(&poochPSN, skipNodeZeroID, &jobObject, kAEYes); 
						
						//	delete node (numNodes + 1) of j  --trims last node to 4, just in case
						err=TellPSNDeleteNodeOfJob(&poochPSN, numNodes+1, &jobObject); 
						
						//	launch j
						err=TellPSNLaunch(&poochPSN, &jobObject); 
						if (noErr!=err) out=err; 
						else 
							{unsigned long endTime=TickCount()+600; 
							EventRecord theEvent; 
							short waiting=CurrentLaunchInProgress()?false:true; 
							
							out=noErr; 
							
							while (waiting) {
								/*twiddle my thumbs _and give up plenty of background time_
								 until Pooch has finished its task */
						
								if (WaitNextEvent(mDownMask+mUpMask+keyDownMask+keyUpMask+autoKeyMask
									, &theEvent, 60, nil)) 
									; 
						
								if (CurrentLaunchInProgress()) //it's beginning
									waiting=false; 
						
								if (TickCount()>endTime) {//getting impatient
									waiting=false; 
									out=-1; 
									}
						
								}
							
							if ((noErr==out)&&waitForLaunchCompletion) {
								endTime=TickCount()+7200; //wait a couple minutes
								waiting=true; 
								
								do {
									/*twiddle my thumbs _and give up plenty of background time_
									 until Pooch has finished its task */
					
									if (WaitNextEvent(mDownMask+mUpMask+keyDownMask+keyUpMask+autoKeyMask
										, &theEvent, 60, nil)) 
										; 
					
									if (!CurrentLaunchInProgress()) //it's done!
										waiting=false; 
					
									if (TickCount()>endTime) {//getting impatient
										waiting=false; 
										out=-2; 
										}
					
									} while (waiting); 
								
								err=PutMeInForeground(); 
								
								}
							
							}
						
						}
					else 
						out=err;
					
					err=AEDisposeDesc(&nodeListDesc); 
					}
				else 
					out=err; 
				
				}
			else 
				out=err; 
			
			err=AEDisposeDesc(&jobObject); 
			}
		else 
			out=err;
		
		}
	else 
		out=kOTNotFoundErr; 
	
	return out; 
	}

Boolean CurrentLaunchInProgress()
	{ProcessSerialNumber poochPSN; 
	Boolean out=false; 
	OSErr err; 
	
	if (LocateLocalAppWithCreatorCode(&poochPSN, nil, poochCreatorCode)) 
		{
		AEAddressDesc targetAddr; 
		err=AECreateDesc(typeProcessSerialNumber, &poochPSN, sizeof(ProcessSerialNumber), &targetAddr); 

		if (noErr==err) {
			AppleEvent myAE; 
			
			err=AECreateAppleEvent(kAECoreSuite, 'getd', /*get */
				&targetAddr, kAutoGenerateReturnID, kAnyTransactionID, &myAE); 
			if (noErr==err) {
				AEDesc idData; 
				DescType id=currentlyLaunchingID; 
				err=AECreateDesc(typeType, &id, sizeof(DescType), &idData); 
				if (noErr==err) {
					AEDesc objSpec; 
					AEDesc containerDesc; 
					
					err=AECreateDesc(typeNull, &containerDesc, 0, &containerDesc); 
					
					if (noErr==err) {
						/*  launching a parallel job */
						err=CreateObjSpecifier(typeProperty, &containerDesc, formPropertyID, &idData, true, &objSpec); 
						
						if (noErr==err) {
							err=AEPutKeyDesc(&myAE, keyDirectObject, &objSpec); 
							
							AEDisposeDesc(&objSpec); 
							}
						}
					
					}
				
				if (noErr==err) {
					AppleEvent reply; 
					
					err = AESend(&myAE, &reply, kAEWaitReply|kAEAlwaysInteract|kAECanSwitchLayer, 
						kAEHighPriority, kAEDefaultTimeout, nil, nil); 
					
					if (noErr==err) {
						DescType returnedType, answer; 
						Size returnedSize; 
						/* result goes here */
						err=AEGetKeyPtr(&reply, keyDirectObject, typeEnumerated, &returnedType, 
							&answer, sizeof(DescType), &returnedSize); 
						
						if (kAEYes==answer) out=true; 
						
						err=AEDisposeDesc(&reply); 
						
						}
					
					}
				
				err = AEDisposeDesc(&myAE); 
				}
		
			err = AEDisposeDesc(&targetAddr); 
			}
		
		}
	
	return out; 	
	}
